
package de.ivu.elect.presentation.entschaedigung;

import javax.annotation.PostConstruct;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.entschaedigung.boundary.EntschaedigungsartBoundaryCreate;
import de.ivu.elect.business.entschaedigung.entity.Entschaedigungsart;
import de.ivu.elect.business.entschaedigung.entity.EntschaedigungsartMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.presentation.View;
import de.ivu.elect.jee.presentation.redirect.Redirect;

@Named(AbstractEntschaedigungsartCreateNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractEntschaedigungsartCreateNoScopeView.VIEW_ID, useCase = UseCasePermission.ENTSCHAEDIGUNGSART_CREATE)
public abstract class AbstractEntschaedigungsartCreateNoScopeView extends de.ivu.elect.presentation.AbstractElectCreateView<Entschaedigungsart> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "entschaedigungsartCreateView";

  public static final String VIEW_ID = "/entschaedigung/entschaedigungsart-create.xhtml";

  public static final String PARENT_VIEW_ID = "/entschaedigung/entschaedigungsart-search.xhtml";

  @Inject
  protected transient EntschaedigungsartBoundaryCreate create;

  protected Entschaedigungsart entity;

  @Inject
  protected transient EntschaedigungsartMeta entityMeta;

  
  @PostConstruct
  public void init() {
    setEntity(new  Entschaedigungsart());
  }

  

  public Entschaedigungsart getEntity() {
    return entity;
  }

  protected void setEntity(Entschaedigungsart entity) {
    this.entity = entity;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.ENTSCHAEDIGUNGSART_CREATE)
  public String save() {
    callSave(getEntity());

    addMessageSaveSuccess(getEntity());

    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  protected void callSave(Entschaedigungsart entity) {
    create.save(entity);
  }

  protected void addMessageSaveSuccess(Entschaedigungsart entity) {
    addInfoMessage("entity.create.action.save.success.message", entityMeta.getEinzahlMessage());
  }

  public boolean isBtnSaveRendered() {
    return hasPermission(UseCasePermission.ENTSCHAEDIGUNGSART_CREATE);
  }

  @Redirect
  public String reset() {
    resetStateAfterAction();

    init();

    return getViewId();
  }

  public boolean isBtnResetRendered() {
    return true;
  }

  @Redirect
  public String cancel() {
    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  public boolean isBtnCancelRendered() {
    return true;
  }

  protected String getViewId() {
    return VIEW_ID;
  }

  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  protected void resetStateAfterAction() {
    // Do nothing.
  }
}
